package mushroom;

import javax.swing.*;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
class MainFrame extends JFrame implements ActionListener
{
    public JTextArea mainArea;
    public MainFrame()
    {
        super("B-Mushroom IDE 1.0");//we're assuming it's 1.0
        setSize(700,800);
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setLayout(new FlowLayout());

        JMenuBar menuBar = new JMenuBar();
        JMenu fileMenu = new JMenu("File");
        fileMenu.setMnemonic(KeyEvent.VK_F);

        JMenuItem newItem = new JMenuItem("New file", KeyEvent.VK_N);
        newItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N, ActionEvent.CTRL_MASK));
        newItem.getAccessibleContext().setAccessibleDescription("Create a new file");
        newItem.setActionCommand("new");
        newItem.addActionListener(this);
        fileMenu.add(newItem);

        JMenuItem openItem = new JMenuItem("Open file", KeyEvent.VK_O);
        openItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O, ActionEvent.CTRL_MASK));
        openItem.getAccessibleContext().setAccessibleDescription("Open a file");
        openItem.setActionCommand("open");
        openItem.addActionListener(this);
        fileMenu.add(openItem);

        JMenuItem saveItem = new JMenuItem("Save file", KeyEvent.VK_S);
        saveItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S, ActionEvent.CTRL_MASK));
        saveItem.getAccessibleContext().setAccessibleDescription("Save file");
        saveItem.setActionCommand("save");
        saveItem.addActionListener(this);
        fileMenu.add(saveItem);

        JMenuItem runItem = new JMenuItem("Run program", KeyEvent.VK_F9);
        runItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F9, ActionEvent.CTRL_MASK));
        runItem.getAccessibleContext().setAccessibleDescription("Run program");
        runItem.setActionCommand("run");
        runItem.addActionListener(this);
        fileMenu.add(runItem);

        menuBar.add(fileMenu);
        setJMenuBar(menuBar);

        //mainArea is preinitialized as a member of Main
        mainArea = new JTextArea();
        mainArea.setFont(new Font("Monospaced", Font.PLAIN, 12));
        mainArea.setLineWrap(false);
        //we don't want wrapping- that will mess up the program
        //Monospaced fonts are ABSOLUTELY ESSENTIAL for Befunge to make sense

        JScrollPane mainPane = new JScrollPane(mainArea);
        //policy-setting code is deliberately left out because defaults are needed
        mainPane.setPreferredSize(new Dimension(650,700));
        add(mainPane);

        setVisible(true);
    }

    public void actionPerformed(ActionEvent evt)
    {
        String cmd = evt.getActionCommand();
        if(cmd.equalsIgnoreCase("run"))
        {
            new Interpreter(mainArea.getText());
        }
        else if(cmd.equalsIgnoreCase("save"))
        {
            //save file
        }
        else if(cmd.equalsIgnoreCase("new"))
        {
            String filename = JOptionPane.showInputDialog(null,"Enter a name for your new file:");
            File newFile = new File(filename);
            newFile.mkdirs();
            try
            {
                newFile.createNewFile();
            }
            catch(IOException e)
            {
                JOptionPane.showMessageDialog(null,"An error occured. We apologize for the inconvenience.",
                    "Error",JOptionPane.ERROR_MESSAGE);
            }
        }
        else if(cmd.equalsIgnoreCase("open"))
        {
            String filename = JOptionPane.showInputDialog("What file to open?");
            File file = new File(filename);
            if(!file.exists())
            {
                JOptionPane.showMessageDialog(null,
                    "This file does not exist.\nYou may create this file through CTRL+N - ENTER.",
                    "Error", JOptionPane.ERROR_MESSAGE);
                return;
            }
            try {
				FileReader stream = new FileReader(file);
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
            //more to come later
        }
    }
}

public class Main
{
    public static void main(String[] args)
    {
        new MainFrame();
    }
}
