package pku.sei.dependencegraph.graph;

public final class IPathType_1 {
	public static final int S_S = 0;
	public static final int S_SL = 1;
	public static final int S_SR = 2;
	public static final int S_SM = 3;
	public static final int S_MAX = 4; // must be larger than any other S_Xs
	public static boolean toBeExpanded(int pathType) {
		return pathType != S_SM;
	}
	public static boolean isRightBrace(int pathType) {
		return pathType < -S_MAX;
	}
	public static boolean isLeftBrace(int pathType) {
		return pathType > S_MAX;
	}
	public static int convert2PathType(int edgeType) {
		if (edgeType == 0)
			return 0;
		else if (edgeType < 0)
			return edgeType - S_MAX;
		else
			return edgeType + S_MAX;
	}
	public static String convert2Str(int pathType) {
		switch (pathType) {
		case S_S:
			return "S";
		case S_SL:
			return "L";
		case S_SR:
			return "R";
		case S_SM:
			return "M";
		}
		return new Integer(pathType).toString();
	}
}
